import peasy.*;

PeasyCam cam;

PVector pRay = new PVector(0, 0, 0);
PVector pRayDir = new PVector(-.2, .5, 1);

PVector p1 = new PVector(0, 100, 100);
PVector p2 = new PVector(100, -100, 100);
PVector p3 = new PVector(-100, 0, 150);


void setup()
{
  // set the window size + 3d mode
  size(800, 600, P3D);

  // setup the camera
  cam = new PeasyCam(this, 1500);
  cam.setMinimumDistance(5);
  cam.setMaximumDistance(5000);
  perspective(radians(25), (float)width / (float)height, .1, 5000);
}

void draw()
{
  background(0);

  coordSys(100);

  // draw triangle
  stroke(255, 0, 150);
  beginShape(TRIANGLES);
  vertex(p1.x, p1.y, p1.z);
  vertex(p2.x, p2.y, p2.z);
  vertex(p3.x, p3.y, p3.z);
  endShape();

  // draw ray
  stroke(255, 255, 0);
  drawRay(pRay,pRayDir);

  // check if the ray hits the triangle
  PVector hit = new PVector();
  if (triangleIntersection(pRay, 
                           pRayDir, 
                           p1, p2, p3, 
                           hit))
  {
    strokeWeight(15);
    stroke(255, 0, 0);
    point(hit.x, hit.y, hit.z);
    strokeWeight(1);
  }
}

